#pragma once


#include "grammar.hpp"


typedef enum parse_token {
	TOK_BLOCK = 256,
	TOK_CHAR = 257,
	TOK_SQBLOCK = 258,
	TOK_STRING = 259,
	TOK_SYMBOL = 260,
	TOK_SYMBOL_UC = 261,
} parse_token_t;

typedef struct parse_token_value {
	char c;
	std::string *str;
} parse_token_value_t;

typedef struct parse_context parse_context_t;

parse_context_t * parse_alloc(void *(*alloc_func)(size_t));
void parse_free(parse_context_t *parser, void (*free_func)(void *));

int parse_push(parse_context_t *parser, int token, const parse_token_value_t *value, __attribute__((unused)) solar::grammar_t *grammar);
